import { PrestashopRequestParameters } from './static/parameters';
interface PrestashopApiConfig {
    url: string;
    token: string;
}
export declare class PrestashopApi {
    private readonly config;
    private readonly base64_token;
    constructor(config: PrestashopApiConfig);
    private buildQuery;
    private buildUrl;
    private adaptsBodyToLanguages;
    /**
     * Executes the query passed in parameter until it succeeds
     * @param query Query to execute
     * @param retry Current recurrence
     * @private
     */
    private executeQuery;
    /**
     * Retrieves data from the resource passed in parameter
     * @param params
     */
    get(params: PrestashopRequestParameters): Promise<any>;
    /**
     * Create data with a body
     * @param params
     * @param body
     */
    post(params: PrestashopRequestParameters, body: any): Promise<any>;
    /**
     * Modify data by entering a body and filters
     * @param params
     * @param body
     */
    put(params: PrestashopRequestParameters, body: any): Promise<any>;
    /**
     * Delete data by entering a body and filters
     * @param params
     */
    delete(params: PrestashopRequestParameters): Promise<any>;
}
export {};
