"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrestashopApi = void 0;
// @ts-ignore
var http_build_query_1 = require("http-build-query");
// @ts-ignore
var base_64_1 = require("base-64");
// @ts-ignore
var object_to_xml_1 = require("object-to-xml");
var axios_1 = require("axios");
var any = http_build_query_1.default.httpBuildQuery;
var o2x = object_to_xml_1.default.o2x;
var PrestashopApi = /** @class */ (function () {
    function PrestashopApi(config) {
        this.config = config;
        this.base64_token = base_64_1.default.encode(config.token);
    }
    PrestashopApi.prototype.buildQuery = function (options) {
        var urlParams = {};
        var query = '';
        for (var _i = 0, _a = Object.keys(options); _i < _a.length; _i++) {
            var keyOption = _a[_i];
            urlParams[keyOption] = options[keyOption];
        }
        if (Object.entries(urlParams).length > 0) {
            query = "".concat((0, http_build_query_1.default)(urlParams));
        }
        return query;
    };
    PrestashopApi.prototype.buildUrl = function (config, params, deleteRequest) {
        if (deleteRequest === void 0) { deleteRequest = false; }
        if (deleteRequest && params.id)
            return "".concat(config.url, "api/").concat(params.resource, "/").concat(params.id, "?ws_key=").concat(config.token);
        var query = this.buildQuery(params);
        var route = "".concat(config.url, "api/").concat(params.resource);
        if (params.id) {
            route = "".concat(route, "/").concat(params.id);
        }
        route = "".concat(route, "?ws_key=").concat(config.token, "&output_format=JSON&").concat(query).concat(params._blank ? '&schema=blank' : '');
        return route;
    };
    PrestashopApi.prototype.adaptsBodyToLanguages = function (body) {
        var _a;
        var formatBody = function (resourceKey, bodyToFormat) {
            for (var _i = 0, _a = Object.entries(bodyToFormat[resourceKey]); _i < _a.length; _i++) {
                var _b = _a[_i], key = _b[0], value = _b[1];
                if (Array.isArray(value) && value.length > 0 && value[0].id && (value[0].value || value[0].value === null)) {
                    bodyToFormat[resourceKey][key] = {
                        language: bodyToFormat[resourceKey][key].map(function (val) { return (__assign({ '@': {
                                id: val.id
                            } }, (val.value ? { '#': val.value } : {}))); })
                    };
                }
            }
            return bodyToFormat;
        };
        if (Array.isArray(body) && body.length > 0) {
            var resourceKey_1 = Object.keys(body[0])[0];
            return _a = {}, _a[resourceKey_1] = body.map(function (b) { return formatBody(resourceKey_1, b)[resourceKey_1]; }), _a;
        }
        else {
            var resourceKey = Object.keys(body)[0];
            return formatBody(resourceKey, body);
        }
    };
    /**
     * Executes the query passed in parameter until it succeeds
     * @param query Query to execute
     * @param retry Current recurrence
     * @private
     */
    PrestashopApi.prototype.executeQuery = function (query, retry) {
        if (retry === void 0) { retry = 0; }
        return __awaiter(this, void 0, void 0, function () {
            var result, error_1, randomInt;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (retry >= 10) {
                            return [2 /*return*/, null];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, query()];
                    case 2:
                        result = _a.sent();
                        if (result.status !== 503) {
                            return [2 /*return*/, result.data];
                        }
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        return [3 /*break*/, 4];
                    case 4:
                        randomInt = Math.floor(Math.random() * (6000 - 3000 + 1)) + 3000;
                        return [4 /*yield*/, new Promise(function (resolve) { return setTimeout(resolve, randomInt); })];
                    case 5:
                        _a.sent();
                        return [2 /*return*/, this.executeQuery(query, retry + 1)];
                }
            });
        });
    };
    /**
     * Retrieves data from the resource passed in parameter
     * @param params
     */
    PrestashopApi.prototype.get = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var url, query, response;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.buildUrl(this.config, params);
                        query = function () { return __awaiter(_this, void 0, void 0, function () {
                            var response_1, error_2;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, axios_1.default.get(url, {
                                                headers: {
                                                    'Authorization': "Basic ".concat(this.base64_token),
                                                    'Content-Type': 'application/json'
                                                }
                                            })];
                                    case 1:
                                        response_1 = _a.sent();
                                        return [2 /*return*/, response_1];
                                    case 2:
                                        error_2 = _a.sent();
                                        return [2 /*return*/, error_2.response];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, this.executeQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    /**
     * Create data with a body
     * @param params
     * @param body
     */
    PrestashopApi.prototype.post = function (params, body) {
        return __awaiter(this, void 0, void 0, function () {
            var url, query, response;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.buildUrl(this.config, params);
                        query = function () { return __awaiter(_this, void 0, void 0, function () {
                            var response_2, error_3;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, axios_1.default.post(url, o2x({
                                                '?xml version=\"1.0\" encoding=\"UTF-8\"?': null,
                                                prestashop: this.adaptsBodyToLanguages(body)
                                            }), {
                                                headers: {
                                                    'Authorization': "Basic ".concat(this.base64_token),
                                                    'Content-Type': 'application/xml'
                                                },
                                                maxBodyLength: Infinity,
                                                maxContentLength: Infinity
                                            })];
                                    case 1:
                                        response_2 = _a.sent();
                                        return [2 /*return*/, response_2];
                                    case 2:
                                        error_3 = _a.sent();
                                        return [2 /*return*/, error_3.response];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, this.executeQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    /**
     * Modify data by entering a body and filters
     * @param params
     * @param body
     */
    PrestashopApi.prototype.put = function (params, body) {
        return __awaiter(this, void 0, void 0, function () {
            var url, query, response;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.buildUrl(this.config, params);
                        query = function () { return __awaiter(_this, void 0, void 0, function () {
                            var response_3, error_4;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, axios_1.default.put(url, o2x({
                                                '?xml version=\"1.0\" encoding=\"UTF-8\"?': null,
                                                prestashop: this.adaptsBodyToLanguages(body)
                                            }), {
                                                headers: {
                                                    'Authorization': "Basic ".concat(this.base64_token),
                                                    'Content-Type': 'text/xml'
                                                },
                                                maxBodyLength: Infinity,
                                                maxContentLength: Infinity
                                            })];
                                    case 1:
                                        response_3 = _a.sent();
                                        return [2 /*return*/, response_3];
                                    case 2:
                                        error_4 = _a.sent();
                                        return [2 /*return*/, error_4.response];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, this.executeQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    /**
     * Delete data by entering a body and filters
     * @param params
     */
    PrestashopApi.prototype.delete = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            var url, query, response;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = this.buildUrl(this.config, params, true);
                        query = function () { return __awaiter(_this, void 0, void 0, function () {
                            var response_4, error_5;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        _a.trys.push([0, 2, , 3]);
                                        return [4 /*yield*/, axios_1.default.delete(url)];
                                    case 1:
                                        response_4 = _a.sent();
                                        return [2 /*return*/, response_4];
                                    case 2:
                                        error_5 = _a.sent();
                                        return [2 /*return*/, error_5.response];
                                    case 3: return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, this.executeQuery(query)];
                    case 1:
                        response = _a.sent();
                        return [2 /*return*/, response];
                }
            });
        });
    };
    return PrestashopApi;
}());
exports.PrestashopApi = PrestashopApi;
