interface PrestashopPrice {
    country?: number;
    state?: number;
    postcode?: number;
    currency?: number;
    group?: number;
    quantity?: number;
    product_attribute?: number;
    decimals?: number;
    use_tax?: boolean;
    use_reduction?: boolean;
    only_reduction?: boolean;
    use_ecotax?: boolean;
    [x: string | number]: unknown;
}
export interface PrestashopRequestParameters {
    resource: resource | string;
    id?: number;
    id_shop_default?: number;
    filter?: any;
    display?: string;
    sort?: string;
    limit?: number | string;
    _blank?: boolean;
    schema?: string;
    id_shop?: number;
    id_group_shop?: number;
    price?: {
        with_tax?: PrestashopPrice;
        without_tax?: PrestashopPrice;
    };
    date?: boolean;
    [x: string | number]: unknown;
}
declare type resource = 'addresses' | 'attachments' | 'carriers' | 'cart_rules' | 'carts' | 'categories' | 'combinations' | 'configurations' | 'contacts' | 'content_management_system' | 'countries' | 'currencies' | 'customer_messages' | 'customer_threads' | 'customers' | 'customizations' | 'deliveries' | 'employees' | 'groups' | 'guests' | 'image_types' | 'images' | 'languages' | 'manufacturers' | 'messages' | 'order_carriers' | 'order_cart_rules' | 'order_details' | 'order_histories' | 'order_invoices' | 'order_payments' | 'order_slip' | 'order_states' | 'orders' | 'price_ranges' | 'product_customization_fields' | 'product_feature_values' | 'product_features' | 'product_option_values' | 'product_options' | 'product_suppliers' | 'products' | 'search' | 'shop_groups' | 'shop_urls' | 'shops' | 'specific_price_rules' | 'specific_prices' | 'states' | 'stock_availables' | 'stock_movement_reasons' | 'stock_movements' | 'stocks' | 'stores' | 'suppliers' | 'supply_order_details' | 'supply_order_histories' | 'supply_order_receipt_histories' | 'supply_order_states' | 'supply_orders' | 'tags' | 'tax_rule_groups' | 'tax_rules' | 'taxes' | 'translated_configurations' | 'warehouse_product_locations' | 'warehouses' | 'weight_ranges' | 'zones';
export {};
